#include <hmg.ch>

Function Main

   aSudoku := {{0,0,0,0,0,3,8,0,1},;
               {0,0,0,7,0,6,0,5,2},;
               {0,0,2,0,0,0,0,7,9},;
               {0,0,0,1,5,7,9,3,4},;
               {0,0,3,0,0,0,1,0,0},;
               {9,1,7,3,8,4,0,2,0},;
               {1,8,0,0,0,0,0,0,6},;
               {7,3,0,6,0,1,0,0,0},;
               {6,0,5,8,0,9,0,0,0}}
               
  aOriginal := {}  
  aOriginal := aclone(aSudoku)
  
  cSudoku :={{'','','','','','','','',''},;  
             {'','','','','','','','',''},;
             {'','','','','','','','',''},;
             {'','','','','','','','',''},;
             {'','','','','','','','',''},;
             {'','','','','','','','',''},;
             {'','','','','','','','',''},;
             {'','','','','','','','',''},;
             {'','','','','','','','',''}}
  
  
  private cRed := { 200,100,100 } 
  private cBlu := { 100,100,200 } 
  private cGre := { 100,200,100 } 
  private cYel := { 200,200, 50 }             	
  private cBg  := { || f_colBg( This.CellRowIndex, This.CellColIndex) }	
                      
  cct  :=  {"TEXTBOX","CHARACTER","9"}
  cct9 :=  {cct,cct,cct,cct,cct,cct,cct,cct,cct}
  
  cen  :=  {||entergrid( This.CellRowIndex, This.CellColIndex)}
  cen9 :=  {cen,cen,cen,cen,cen,cen,cen,cen,cen}

  cck  :=  {||checkgrid( This.CellRowIndex, This.CellColIndex, This.CellValue)}
  cck9 :=  {cck,cck,cck,cck,cck,cck,cck,cck,cck}

  wi9  :=  {50,50,50,50,50,50,50,50,50}
  refresh_grid()

        Load Window Main
        Main.Center
        Main.Activate

Return
*-----------------------------------------------------

procedure refresh_grid()

  for i:=1 to 9
  for j:=1 to 9
    cSudoku[i,j]:= iif( aSudoku[i,j]=0 , '' , str(aSudoku[i,j],1,0) )
  endfor
  endfor
return nil

*-----------------------------------------------------

function sqare_check(p_i,p_j,p_n_Val)
  i3:= 3 * p_i
  i1:= i3 - 2
  j3:= 3 * p_j
  j1:= j3 - 2
  for i:=i1 to i3
  for j:=j1 to j3
    if aSudoku[i,j]==p_n_Val
      retu .t.
    endif
  endfor
  endfor
retu .f.


*-----------------------------------------------------

function checkgrid(ro,co,va)
  local n_Val := val(alltrim(va))
  local l_Val := .t.
  
  
  for i:=1 to 9
    if aSudoku[i,co]==n_Val
      l_Val:=.f.
    endif
    if aSudoku[ro,i]==n_Val
      l_Val:=.f.
    endif
  endfor
  
  co123 := int((co+2)/3) 
  ro123 := int((ro+2)/3)    

  if sqare_check(co123,ro123,n_Val)
    l_Val:=.f.
  endif
  
  
  if !l_Val
    aSudoku[ro,co]:=0
    This.CellValue := ''
  endif
  
  refresh_grid()
  Main.Grid_1.Refresh
  

return l_Val             

*-----------------------------------------------------

function entergrid(ro,co)
return iif( aOriginal[ro,co] > 0, .f. , .t. )             

*-----------------------------------------------------

function f_colBg(ro,co)
  co123 := int((co-1)/3) 
  ro123 := int((ro-1)/3)    
  i     := 3*co123 + ro123
  do case
    case i=0
      return cRed
    case i=1
      return cGre
    case i=2
      return cBlu
    case i=3
      return cGre
    case i=4
      return cYel
    case i=5
      return cGre
    case i=6
      return cBlu
    case i=7
      return cGre
    case i=8
      return cRed
  endcase
return cYel
  